//  Sound Blaster- ////////////////////////////////////////////////////
enum{SoundBlaster10=1,
//     SoundBlaster15,
     SoundBlaster20,
     SoundBlasterPro,
     SoundBlaster16,
     SoundBlasterAwe32,
     SoundBlasterEss};



//  ⠭ ///////////////////////////////////////////////////////
// ᨬ쭮 ⢮ 
#define MaxVoices 64

// ᨬ쭮 ⢮ ᥬ
#ifdef __DOS32__
 #define MaxSamples 64
#endif
#ifdef __MSDOS__
 #define MaxSamples 32
#endif



// ६ ன Sound Blaster- /////////////////////////////////////
//   㭤 
:word SbIoAddr = 000h;
// IRQ 㭤 
:word SbIrq    = 000h;
// 8- DMA  㭤 
:word SbDma    = 001h;
// Rate 㭤 
:dword SbRate  = 000h;
// Rate 맮 IRQ (50 Hz)
:word IrqRate  = 50;
//  㪮 
:byte SbType   = 0;
// ⢮ 
:word SbNumVoices=MaxVoices;
// ஬ (訥 4  -  , 訥 4  - ࠢ)
:byte SbVol=0FFh;
// Master Volume
:byte SbMasterVol=0FFh;
// ८   뢮 (0 - mono, 1 - stereo)
:byte SbStereo;
//  ⮨樠樥  
:byte SbAutoInit;
// Sb16BitQuality
:byte Sb16BitOutput=FALSE;
//  DSP
:word DspVersion;



// ६ ஢  Sound Blaster- ///////////////////////////////////
//  ࠡ祣 
:word SbWorkBufSize;
//  ࠡ祣  (FirstBuf at start)
:byte SbWorkBufNum=0;

#ifdef __MSDOS__
 //  ࠡ稩 
 :word SbWorkBufSeg;
 :word SbWorkBufOffs;
 //  ॢ
 :word SbClipTableBufSeg;
 :word SbClipTableBufOffs;  // = 0
 // 16-  ஢
 :word SbMixBufSeg;
 :word SbMixBufOffs;   // = 0
#endif

#ifdef __DOS32__
 //  ࠡ稩 
 :word SbWorkBufSeg;
 :word SbWorkBufSel;
 :dword SbWorkBufOffs;
 //  ॢ
 :word SbClipTableBufSeg;
 :word SbClipTableBufSel;
 :dword SbClipTableBufOffs;  // = 0
 // 16-  ஢
 :word SbMixBufSeg;
 :word SbMixBufSel;
 :dword SbMixBufOffs;   // = 0
#endif



//  ᥬ
:struct SAMPLE
{
  word Seg;                //  ᥬ
 #ifdef __DOS32__
  word Sel;                //  ᥬ
 #endif
 #ifdef __MSDOS__
  word Offs;               // 饭 ᥬ
 #endif
 #ifdef __DOS32__
  dword Offs;              // 饭 ᥬ
 #endif
 dword Length;             //  ᥬ
 fixed Pos;                //   ᥬ (fixed 16:16)
 dword Rate;               //  ந ᥬ
 byte Volume;              // ஬ ᥬ
 byte Balance;             //  (0...255)
 word RepeatOffs;          // 饭 砫 横  (Not Supported)
 word RepeatLength;        //  横            (Not Supported)
}Sample[MaxSamples];



//  
:struct VOICE
{
 SAMPLE Sample; // 
 byte Active;   //  ⨢ 
 byte Flags;    //  ࠡ 
}Voice[MaxVoices];



//  ண ࠡ稪 뢠
#ifdef __MSDOS__
:word OldSbIrqHandler[2];
#endif
#ifdef __DOS32__
:dword OldSbIrqHandler[2];
#endif



//   (  ন)
#define VoicePausedFlag    00000001b // ਮ⠭ ந 
#define VoiceDisabledFlag  00000010b // 몫祭 㪠 
#define VoiceNoMixFlag     00000100b //  㥬  (
                                     // ⤥묨 ।⢠)


//  䠩 ///////////////////////////////////////////////////////////
#define LeftFmStatus             000h    // 쪮 Sound Blaster Pro
#define LeftFmAddress            000h    // 쪮 Sound Blaster Pro
#define LeftFmData               001h    // 쪮 Sound Blaster Pro
#define RightFmStatus            002h    // 쪮 Sound Blaster Pro
#define RightFmAddress           002h    // 쪮 Sound Blaster Pro
#define RightFmData              003h    // 쪮 Sound Blaster Pro
#define MixerAddress             004h    // 쪮 Sound Blaster Pro
#define MixerData                005h    // 쪮 Sound Blaster Pro
#define DspReset                 006h    //   DSP
#define FmStatus                 008h
#define FmAddress                008h
#define FmData                   009h
#define DspReadData              00Ah
#define DspWriteData             00Ch
#define DspWriteStatus           00Ch
#define DspDataAvail             00Eh
#define CdRomData                010h    // 쪮 Sound Blaster Pro
#define CdRomStatus              011h    // 쪮 Sound Blaster Pro
#define CdRomReset               012h    // 쪮 Sound Blaster Pro
#define CdRomEnable              013h    // 쪮 Sound Blaster Pro
#define DisableStereoInputMode   0A0h    // SBPro Only
#define EnableStereoInputMode    0A8h    // SBPro Only

#define AdlibFmStatus      0388h
#define AdlibFmAddress     0388h
#define AdlibFmData        0389h

//  DSP
#define Direct8BitDac                010h
#define Dma8BitDac                   014h
#define Dma2BitDac                   016h
#define Dma2BitRefDac                017h
#define Dma8BitDacAutoInit           01Ch
#define DirectAdc                    020h
#define DmaAdc                       024h
#define MidiReadPoll                 030h
#define MidiReadIrq                  031h
#define MidiWritePoll                038h
#define TimeConstant                 040h
//#define Dma8BitDacHiInit             048h   //  high-speed SB Pro transfers
#define SetDmaBlockSize              048h   //  high-speed SB Pro transfers
#define Dma4BitDac                   074h
#define Dma4BitRefDac                075h
#define Dma26BitDac                  076h
#define Dma26BitRefDac               077h
#define Dma8BitDacHiStart            091h   //  high-speed SB Pro transferss
#define Dma8BitAdcHiStart            099h   //  high-speed SB Pro transferss
#define HaltDma                      0D0h
#define ContinueDma                  0D4h
#define SpeakerOn                    0D1h
#define SpeakerOff                   0D3h
#define DspId                        0E0h
#define DspVer                       0E1h
#define DspCopyright                 0E3h
#define IntRequest                   0F2h
#define Mdac1                        061h
#define Mdac2                        062h
#define Mdac3                        063h
#define Mdac4                        064h
#define Mdac5                        065h
#define Mdac6                        066h
#define Mdac7                        067h
#define HiSpeedDma8BitAutoInitDac    090h   // Auto-Initialize DMA DAC, 8-bit (High Speed)         SB2.0-Pro2
#define HiSpeedDma8BitAutoinitAdc    098h   // Auto-Initialize DMA ADC, 8-bit (High Speed)         SB2.0-Pro2
#define ExitDma16BitAutoInitDac      0D9h   // Exit Auto-Initialize DMA Operation, 16-bit          SB16
#define ExitDma8BitAutoInitDac       0DAh   // Exit Auto-Initialize DMA Operation, 8-bit           SB2.0

// 䠩  
#define MasterVol                    022h
#define VocVol                       004h
#define LineVol                      02eh
#define FmVol                        026h
#define CdVol                        028h
#define RecordSrc                    00Ch
#define Mic                          011h
#define LineIn                       017h
#define Cd                           013h

//  8- DMA
#define DmaMask8Bit                  00Ah     // DMAC mask (write-only)
#define Mode8Bit                     00Bh     // DMAC mode (read/write)
#define BytePtr8Bit                  00Ch     // DMAC mode (read/write)
//  16- DMA
#define DmaMask16Bit                 0D4h     // DMAC mask (write-only)
#define Mode16Bit                    0D6h     // DMAC mode (read/write)
#define BytePtr16Bit                 0D8h     // DMAC mode (read/write)

#define ReadCmd  048h    // read (from memory) mode  [out to bus]
#define WriteCmd 044h    // write (to memory) mode   [in from bus]
#define ResetCmd 004h    // DMA_MASK reset

// Mixer
#define MixerReset                   000h     // Write       SBPro
#define MixerStatus                  001h     // Read        SBPro
#define MixerMasterVol               002h     // Read/Write  SBPro Only
#define MixerDACLevel                004h     // Read/Write  SBPro
#define MixerFMOutputControl         006h     // Read/Write  SBPro Only
#define MixerMicLevel                00Ah     // Read/Write  SBPro
#define MixerInputFilterSelect       00Ch     // Read/Write  SBPro Only
#define MixerOutputStereoSelect      00Eh     // Read/Write  SBPro Only
// #define MixerMasterVol               022h     // Read/Write  SBPro
#define MixerFMLevel                 026h     // Read/Write  SBPro
#define MixerCDAudioLevel            028h     // Read/Write  SBPro
#define MixerLineInLevel             02Eh     // Read/Write  SBPro
#define MixerMasterVolLeft           030h     // Read/Write  SB16
#define MixerMasterVolRight          031h     // Read/Write  SB16
#define MixerDACLevelLeft            032h     // Read/Write  SB16
#define MixerDACLevelRight           033h     // Read/Write  SB16
#define MixerFMLevelLeft             034h     // Read/Write  SB16
#define MixerFMLevelRight            035h     // Read/Write  SB16
#define MixerCDAudioLevelLeft        036h     // Read/Write  SB16
#define MixerCDAudioLevelRight       037h     // Read/Write  SB16
#define MixerLineInLevelLeft         038h     // Read/Write  SB16
#define MixerLineInLevelRight        039h     // Read/Write  SB16
// #define MixerMicLevel                03Ah     // Read/Write  SB16
#define MixerPCSpeakerLevel          03Bh     // Read/Write  SB16
#define MixerOutputControl           03Ch     // Read/Write  SB16
#define MixerInputControlLeft        03Dh     // Read/Write  SB16
#define MixerInputControlRight       03Eh     // Read/Write  SB16
#define MixerInputGainControlLeft    03Fh     // Read/Write  SB16
#define MixerInputGainControlRight   040h     // Read/Write  SB16
#define MixerOutputGainControlLeft   041h     // Read/Write  SB16
#define MixerOutputGainControlRight  042h     // Read/Write  SB16
#define MixerTrebleLeft              044h     // Read/Write  SB16
#define MixerTrebleRight             045h     // Read/Write  SB16
#define MixerBassLeft                046h     // Read/Write  SB16
#define MixerBassRight               047h     // Read/Write  SB16
#define MixerIRQSelect               080h     // Read/Write  SB16
#define MixerDMASelect               081h     // Read/Write  SB16
#define MixerIRQStatus               082h     // Read        SB16

:byte PagePort[4]={ 087h,083h,081h,082h, 08Fh,08Bh,089h,08Ah };
:byte AddressPort[4]={ 000h,002h,004h,006h, 0C0h,0C4h,0C8h,0CCh };

// 䠩  ESS-
#define EssWriteCommand              0C0h
#define EssEnterExtendedMode         0C6h
#define EssExitExtendedMode          0C7h

