// ᨬ쭮 ⢮ -ᥬ
#define MaxModSamples 31
#define MaxPatterns   256



//  ਯ 
struct BUFFERDESCRIPTOR
{
 dword Sel;      // 
 dword Handle;   // Handle
};



//  -ᥬ (30 bytes)
struct MODSAMPLE
{
 byte Name[22];                      //  ᥬ
 word Length;                        //  ᥬ
 byte FineTune;                      // 祭 ⮭ ⮭
 byte Volume;                        // ஬ ᥬ
 word LoopOffs;                    // 饭 横 ᥬ
 word LoopLength;                  //  横 ᥬ
};



//  - (1084 bytes)
struct MODMODULE
{
 byte Name[20];                      //  ᭨
 MODSAMPLE ModSample[MaxModSamples]; // 
 byte OrderLength;                   //  ᭨  ୠ (1..128)
 byte ReStart;                 //  ୠ, ᫥ 砭 ந뢠
 byte Order[128];              // 冷 ந ୮
 byte Signature[4];            //  

 dword NumSamples;              // ⢮ ᥬ (15...31)
 BUFFERDESCRIPTOR Sample[MaxModSamples];   // ਯ ᥬ
 dword NumPatterns;            // ⢮ ୮
 BUFFERDESCRIPTOR Pattern[MaxPatterns]; // ਯ ୮
 dword NumVoices;            // ⢮ 
 dword OrderPos;             //   ᯨ᪥ । ୮
 byte  PatternLine;          //    ୥
 dword Frame;                // 騩 
 dword SamplesPerFrame;      // ⢮ 롮ப  ३
 dword CurrentFrameSample;   //  ⥪饩 롮ન  ३
 dword NumMixSamples;        // ⢮ 롮ப  ஢
 dword WorkBufOffs;          // 饭  ࠡ祬 
 dword Speed;                // 
 dword BPM;                  // ⢮ 㤠஢  
 byte MasterVolume;          // ᭮ ஬
 byte Play;                  //  ந 樨
 byte ModuleLoaded;          //  㧪 

 byte PatternDelayCount;     // 祭 প ப (Speed*PatternDelayCount ३)

 // ᯮ⥫ 楤
 void static CARRYFLAG fastcall AllocateBuffer(EAX,ESI); // 뤥 
 void static CARRYFLAG fastcall FreeBuffer(EDX);     // । 

 // 楤 ࠢ  ஬
 void static Init();                       // 樠 ⥬
 void static DeInit();                     // 樠 ⥬
 void static fastcall LoadModule(EDX);     // 㧪 
 void static fastcall UnLoadModule();      // 㧪 
 void static fastcall SetBPM(EBX);         // ⠭ BPM
 void static fastcall NextLine();          // 室  ᫥ ப  ୥
 void static fastcall PreviousLine();      // 室  । ப  ୥
 void static fastcall NextPattern();       // 室  ᫥騩   ᯨ᪥
 void static fastcall PreviousPattern();   // 室  ।騩   ᯨ᪥
 void static fastcall OrderEffects();      // ࠡ⪠ 䥪⮢,   冷 ந
 void static fastcall SampleEffects();     // ࠡ⪠ 䥪⮢,   ந ᥬ

 // ᭮ 䥪
 void static fastcall Arpeggio(AL);        // 䥪 Arpeggio
 void static fastcall PortamentoUp(AL);    // 襭  
 void static fastcall PortamentoDown(AL);  //   
 void static fastcall TonePortamento(AL);  // ⠬  
 void static fastcall Vibrato(AL);                // 䥪 Vibrato
 void static fastcall TonePortamentoPlusVolumeSlide(AL); // ⠬   + ᪮즥 ஬
 void static fastcall VibratoPlusVolumeSlide(AL); // Vibrato  ᪮즥 ஬
 void static fastcall Tremolo(AL);                //  ஬
 void static fastcall Pan(AL);                    // ⠭  뢮 㪠 (0..0FFh)
 void static fastcall SampleOffset(EAX);   // ⠭ ᬥ饭  ᥬ
 void static fastcall VolumeSlide(AL);     // 즥 ஬
 void static fastcall PositionJump(AL);    // 室  ᯨ ୮
 void static fastcall SetVolume(AL);       // ⠭ ஬  
 void static fastcall PatternBreak(AL);    // ࢠ 
 void static fastcall SetSpeed(EAX);       // ⠭ ᪮

 // ७ 䥪
 void static fastcall FinePortamentoUp(AL);       //    Y ਮ
 void static fastcall FinePortamentoDown(AL);     //    Y ਮ
 void static fastcall VibratoWaveForm(AL);        // ⠭    䥪 Vibrato
 void static fastcall PatternLoop(AL);            // 横
 void static fastcall TremoloWaveForm(AL);        // ⠭    䥪 Tremolo
 void static fastcall _16PositionPan(AL);         // ⠭  뢮 㪠 (0..0Fh)
 void static fastcall RetrigNote(AL);             //  
 void static fastcall FineVolumeSlideUp(AL);      //  襭 ஬
 void static fastcall FineVolumeSlideDown(AL);    //   ஬
 void static fastcall CutNote(AL);                // १ 
 void static fastcall NoteDelay(AL);              // ঠ 
 void static fastcall PatternDelay(AL);           //  ⢮ ३  ப  Y ࠧ
}ModModule;



//  ୠ
struct PATTERNELEMENT
{
 byte SampleNumber;     //  ᥬ
 word NotePeriod;       // ਮ 
 byte EffectNumber;     //  䥪
 byte EffectParametr;   // ࠬ 䥪
};


